Class.create(function(Super)
 /**
  * JavaScriptDocument(=JSD)IuWFNgt@Ng[NX
  * @param Super [Function|null] X[p[NX
  * @return Function js.debug.jsd.JsdFactoryNX
  * 
  * @package js.debug.jsd
  * @update 2007/12/30
  * @version 1.01.00
  * @author Mug
  * @copyright (C) 2007 Mug, All rights reserved.
  * 
  * @explanation <p>̃NX̓\[XɏꂽJavaScriptDocumentiȉJSDƗjRg͂ăIuWFNgir[j𐶐邽߂̃NXłB
  *   A\[X͕Ƃė^Ȃ΂Ȃ炸AۂɃXNvgt@CƂēǂݍ܂ĂIuWFNgi֐Ȃǁj̕񉻂̓T|[gĂȂB
  *   ́A_ECMAScriptdlł<var>Function.prototype.toString</var>\bh̏eiuEUȂǁjɈς˂Ă邽߂łB</p>
  * @example <p>̃NX(<var>js.debug.jsd.JsdFactory</var>)JSDIuWFNg̗̐ȉɋB</p>
  *   <pre><code>
  *   var source = ("" + js.debug.jsd.JsdFactory);  // F֐toString()̌ʂ͎iuEUȂǁjɂقȂB
  *   
  *   var factory = new js.debug.jsd.JsdFactory(source);
  *   var jsd = factory.create();
  *   </code></pre>
  * 
  * @history 2007/12/30 1.01.00 p[T[o^ɕύXCRXgN^̌@ύX
  * @history 2007/10/08 1.00.00 VK쐬
  */
  {
  //##############################################################################
  //
  // wb_(vpeBEpENXpX)
  //
  //
  // vpeB - NXɊւ郁^f[^
  //
  //:V Creator Function NXNG[^[
  var Creator = arguments.callee;
  // SCNX
  Creator.CompleteName = "js.debug.jsd.JsdFactory";
  
  //
  // p - vg^CvpƊ{õZbg
  //
  // p
  Creator.inherit(Class, Super);
  //:V Static Object StaticIuWFNg
  var Static = Class.Static;
  //:V Proto Object vg^CvIuWFNg
  var Proto = Class.prototype;
  
  //
  // NXpX
  //
  // js.debug.jsd.parser.SourcePoint
  var SourcePoint = js.debug.jsd.parser.SourcePoint;
  // js.debug.jsd.parser.SourceRange
  var SourceRange = js.debug.jsd.parser.SourceRange;
  
  // js.debug.jsd.parser.AbstractParser
  var AbstractParser = js.debug.jsd.parser.AbstractParser;
  
  //##############################################################################
  //
  // {fB(vCx[gENXEStaticEvg^CvE)
  //
  //
  // vCx[g - NX̔Joƃ\bh(pȂ)
  //
  //:V log js.cpt.Log K[
  var log = new js.cpt.Log(Creator.CompleteName);
  
  //:V parserClasses Array gpp[T[NX̔ziʂ͌DIj
  var parserClasses = [];
  
  //------------------------------------------------------------------------------
  //:F findLineSeparator Function
  function findLineSeparator(src)
   /**
    * sR[h
    * @param src String 팟
    * @return String sR[hiKLF,CR,CRLF,LFCR̂ꂩԂj
    */
    {
    if(!src)
      {
      return "\n";
      }
    else if(src.indexOf("\r", 0) < 0)
      {
      return "\n";
      }
    else if(src.indexOf("\n", 0) < 0)
      {
      return "\r";
      }
    else if(src.indexOf("\r\n", 0) >= 0)
      {
      return "\r\n";
      }
    else if(src.indexOf("\n\r", 0) >= 0)
      {
      return "\n\r";
      }
    else
      {
      return "\n";
      }
    }
  
  //
  // NX - NX̌Joƃ\bh(pȂ)
  //
  //------------------------------------------------------------------------------
  Class.registParser = function(parserClass)
   /**
    * p[T[NXo^
    * @notice ͑Ώۂdp[T[NXḿAォo^ꂽ̂̕D悳B
    * @param parserClass Function p[T[NX(js.debug.jsd.parser.AbstractParser̃TuNX)
    * @throw FunctionFormatException@Error parserClass֐łȂꍇ
    * @throw FormatException@Error parserClassjs.debug.jsd.parser.AbstractParser̃TuNXłȂꍇ
    * @throw DoubleDefinitionException@Error p[T[NXdɓo^悤Ƃꍇ
    */
    {
    if((typeof parserClass) != "function")
      {
      throw new Error("FunctionFormatException", Creator.CompleteName, {variable:"parserClass", value:parserClass, type:(typeof parserClass)});
      }
    if(!(parserClass.prototype instanceof AbstractParser))
      {
      throw new Error("FormatException", Creator.CompleteName, {variable:"parserClass", format:"SubClass of js.debug.jsd.parser.AbstractParser", value:parserClass, type:(typeof parserClass)});
      }
    for(var i = 0; i < parserClasses.length; i++)
      {
      if(parserClasses[i] == parserClass)
        {
        throw new Error("DoubleDefinitionException", Creator.CompleteName, "p[T[NXdo^悤Ƃ܂B");
        }
      }
    parserClasses[parserClasses.length] = parserClass;
    };
  
  //
  // Static - NX.StatičJoƃ\bh(p)
  //
  
  //
  // vg^Cv - NX.prototypěJoƃ\bh(p)
  //
  
  //
  //  - NX`ɂP񂾂s
  //
  
  //##############################################################################
  //
  // RXgN^(vCx[gEthisERXgN^)
  //
  function Class(source)
   /**
    * JavaScriptDocumentIuWFNgt@Ng[NX̃RXgN^
    * @param source String ͑Ώۃ\[X
    * @return js.debug.jsd.JsdFactory CX^X
    * @throw StringFormatException@Error sourcev~eBuString^łȂꍇ
    */
    {
    log.trace("JsdFactory() begin - ", source);
    if((typeof source) != "string")
      {
      throw new Error("StringFormatException", Creator.CompleteName, {variable:"source", value:source, type:(typeof source)});
      }
    //
    // X[p[NXKp(p) - X[p[NX̃RXgN^N
    //
    //Super.apply(this, arguments);
    
    //
    // vCx[g - CX^X̔Joƃ\bh(pȂ)
    //
    //:V ls String sR[h
    var ls = "\n";
    //:V allParsers Array|undefined SẴp[T[CX^X̔z
    var allParsers;
    //:V arounds Array|undefined sƂɕꂽ\[XiRgς݁j
    var arounds;
    //:V className String|undefined RXgN^̊֐
    var className;
    //:V classRange js.debug.jsd.parser.SourceRange|undefined RXgN^̃\[X͈
    var classRange;
    //:V jsdParsers Array|undefined RpCɐJSDp[T[CX^X̔z
    var jsdParsers;
    
    //------------------------------------------------------------------------------
    function makeParsers()
     /**
      * sourceallParsersarounds𐶐
      */
      {
      log.trace("makeParsers() - begin");
      // 
      var p = 0;
      if(allParsers instanceof Array)
        {
        allParsers.length = 0;
        }
      else
        {
        allParsers = [];
        }
      var a = 0;
      if(arounds instanceof Array)
        {
        arounds.length = 0;
        }
      else
        {
        arounds = [];
        }
      // source[v
      var index = 0;
      var lineCount = 0;
      var beginIndex = 0;
      var endIndex = 0;
      var parserClass = null;
      var temp, range, matches;
      var aroundSource = "";
      while(index < source.length)
        {
        beginIndex = source.length;
        // ̈v
        parserClass = null;
        for(var c = 0; c < parserClasses.length; c++)
          {
          parserClasses[c].Static.PATTERN.lastIndex = index;
          temp = parserClasses[c].Static.PATTERN.exec(source);
          if(temp && (temp.length == 1))
            {
            if((parserClasses[c].Static.PATTERN.lastIndex - temp[0].length) <= beginIndex)
              {
              beginIndex = parserClasses[c].Static.PATTERN.lastIndex - temp[0].length;
              endIndex = parserClasses[c].Static.PATTERN.lastIndex;
              parserClass = parserClasses[c];
              matches = temp;
              }
            }
          else if(temp && (temp.length >= 2))
            {
            if((parserClasses[c].Static.PATTERN.lastIndex - temp[0].length + temp[0].indexOf(temp[1], 0)) <= beginIndex)
              {
              beginIndex = parserClasses[c].Static.PATTERN.lastIndex - temp[0].length + temp[0].indexOf(temp[1], 0);
              endIndex = beginIndex + temp[1].length;
              parserClass = parserClasses[c];
              matches = temp;
              }
            }
          }
        if(!parserClass)
          {
          beginIndex = source.length;
          endIndex = source.length;
          }
        // ̈v܂łm
        if(beginIndex > index)
          {
          for(temp = index; (temp = source.indexOf(ls, temp)) >= 0; temp += ls.length)
            {
            if(temp >= beginIndex)
              {
              break;
              }
            lineCount++;
            }
          aroundSource += source.substring(index, beginIndex);
          }
        // ̈v
        if(parserClass)
          {
          range = new SourceRange();
          range.begin = new SourcePoint();
          range.begin.lineNumber = lineCount;
          range.begin.charIndex = (lineCount > 0) ? (aroundSource.length - aroundSource.lastIndexOf(ls, aroundSource.length) - ls.length) : aroundSource.length;
          range.value = (matches.length >= 2) ? matches[1] : matches[0];
          matches = parserClass.Static.substitute(range.value);
          if(matches)
            {
            for(temp = 0; (temp = matches.indexOf(ls, temp)) >= 0; temp += ls.length)
              {
              lineCount++;
              }
            aroundSource += matches;
            range.end = new SourcePoint();
            range.end.lineNumber = lineCount;
            range.end.charIndex = (lineCount > range.begin.lineNumber) ? (aroundSource.length - aroundSource.lastIndexOf(ls, aroundSource.length) - ls.length) : (range.begin.charIndex + matches.length);
            }
          else
            {
            range.end = range.begin.clone();
            }
          allParsers[allParsers.length] = new parserClass(range);
          }
        // [vp
        index = endIndex;
        }
      // arounds̐
      arounds = aroundSource.split(ls);
      // RXgN^̌
      findConstructor(aroundSource);
      // ㏈
      delete parserClass;
      delete aroundSource;
      log.trace("makeParsers() - end");
      }
    //------------------------------------------------------------------------------
    function findConstructor(aroundSource)
     /**
      * aroundSourceRXgN^
      * @param aroundSource String ͌̃\[X
      */
      {
      log.trace("findConstructor() - begin - ", aroundSource);
      // 萔
      var LS1 = (ls.length > 1) ? ls.charAt(0) : ls;
      var TOKEN_B = "{";
      var TOKEN_E = "}";
      var FUNC_PATTERN = /(?:^|\s|\W)function(?:\s|\r|\n)+(\S+?)(?:\s|\r|\n)*\((?:.|\r|\n)*?\)(?:\s|\r|\n)*\{$/;
      var RET_PATTERN = /return(?:(?:\s|\r|\n)+(\S+?)|(?:\s|\r|\n)*\((?:\s|\r|\n)*(\S+?)(?:\s|\r|\n)*\))?(?:\s|\r|\n)*;/;
      // 
      className = undefined;
      classRange = undefined;
      // [vϐ
      var funcRangeMap = {};
      var line = 0;
      var nest = ((aroundSource.substring(0, 8) == "function") && (aroundSource.charAt(aroundSource.length - 1) == TOKEN_E)) ? -1 : 0;
      var name, range;
      var zeroSource, zeroBegin = 0;
      // S[v
      for(var i = 0; i < aroundSource.length; i++)
        {
        // ʃlXgx
        switch(aroundSource.charAt(i))
          {
          case LS1:
            if((ls.length <= 1) || (aroundSource.substring(i, (i + ls.length)) == ls))
              {
              line++;
              if(ls.length > 1)
                {
                i += (ls.length - 1);
                }
              break;
              }
          default:
            if(i < (aroundSource.length - 1))
              {
              break;
              }
          case TOKEN_B:
            if((nest == 0) && (i > zeroBegin))
              {
              zeroSource = aroundSource.substring(zeroBegin, i + TOKEN_B.length);  // FTOKEN_B܂܂Ă!
              }
            nest++;
            if(nest == 0)
              {
              zeroBegin = i + TOKEN_B.length;
              }
            break;
          case TOKEN_E:
            nest--;
            if(nest < 0)
              {
              zeroSource = aroundSource.substring(zeroBegin, i + TOKEN_E.length);  // FTOKEN_E܂܂Ă!
              }
            else if(nest == 0)
              {
              if(name && range)
                {
                range.end = new SourcePoint();
                range.end.lineNumber = line;
                range.end.charIndex = aroundSource.lastIndexOf(ls, i);
                range.end.charIndex = (range.end.charIndex < 0) ? (i + TOKEN_E.length) : (i + TOKEN_E.length - range.end.charIndex - 1);
                funcRangeMap[name] = range;
                name = null;
                range = null;
                }
              zeroBegin = i + TOKEN_E.length;
              }
            break;
          }
        // [x
        if(zeroSource)
          {
          // ֐
          var matches = FUNC_PATTERN.exec(zeroSource);
          if(matches && (matches.length > 1))
            {
            name = matches[1];
            range = new SourceRange();
            range.begin = new SourcePoint();
            range.begin.lineNumber = line;
            range.begin.charIndex = aroundSource.lastIndexOf(ls, i);
            range.begin.charIndex = (range.begin.charIndex < 0) ? i : (i - range.begin.charIndex - 1);
            }
          // ^[
          if(!className)
            {
            matches = RET_PATTERN.exec(zeroSource);
            if(matches && (matches.length > 2))
              {
              if(matches[1])
                {
                className = matches[1];
                }
              else if(matches[2])
                {
                className = matches[2];
                }
              }
            }
          zeroSource = null;
          }
        // ς݁H
        if(className && funcRangeMap[className])
          {
          classRange = funcRangeMap[className];
          break;
          }
        }
      // ㏈
      log.trace("findConstructor() - end");
      }
    //------------------------------------------------------------------------------
    function parseAll(force)
     /**
      * SĂallParsersɑ΂ăp[Xs
      * @param force [Boolean] p[XiG[Ă𑱍sj邩ǂ
      * @throw Error p[X[hłȂƂɃp[XG[ꍇ
      */
      {
      log.trace("parseAll() - begin - ", force);
      var p = (jsdParsers = []);
      for(var i = 0; i < allParsers.length; i++)
        {
        // p[X
        if(force)
          {
          try
            {
            if(allParsers[i].parse(arounds))
              {
              p[p.length] = allParsers[i];
              }
            }
          catch(e)
            {
            allParsers[i].jsd = null;
            allParsers[i].target = null;
            allParsers[i].error = e;
            p[p.length] = allParsers[i];
            log.warn("p[X[hŃp[XG[܂B", e);
            }
          }
        // ʏp[X
        else
          {
          if(allParsers[i].parse(arounds))
            {
            p[p.length] = allParsers[i];
            }
          }
        }
      log.trace("parseAll() - end");
      }
    //------------------------------------------------------------------------------
    function autoConnect()
     /**
      * targetłJSD
      */
      {
      log.trace("autoConnect() - begin");
      if(jsdParsers && (jsdParsers.length > 0))
        {
        // 
        var cache = jsdParsers[0];
        for(var i = 1; i < jsdParsers.length; i++)
          {
          if(jsdParsers[i] != cache)
            {
            if(cache.target && jsdParsers[i].target && cache.target.equals(jsdParsers[i].target))
              {
              var cmd = jsdParsers[i].jsd.getCommands();
              for(var c = 0; c < cmd.length; c++)
                {
                cache.jsd.putCommand(cmd[c]);
                }
              delete cmd;
              jsdParsers[i] = cache;
              }
            else
              {
              cache = jsdParsers[i];
              }
            }
          }
        // g
        cache = jsdParsers[0];
        var p = [cache];
        for(var i = 1; i < jsdParsers.length; i++)
          {
          if(jsdParsers[i] != cache)
            {
            cache = jsdParsers[i];
            p[p.length] = cache;
            }
          }
        jsdParsers = p;
        }
      log.trace("autoConnect() - end");
      }
    //------------------------------------------------------------------------------
    function autoDetect()
     /**
      * def,name,type,valueR}htarget玩
      */
      {
      log.trace("autoDetect() - begin");
      // NX̎擾
      var Def  = ((typeof js.debug.jsd.command.Definition) == "function") ? js.debug.jsd.command.Definition : null;
      var Name = ((typeof js.debug.jsd.command.Name)       == "function") ? js.debug.jsd.command.Name       : null;
      var Type = ((typeof js.debug.jsd.command.Type)       == "function") ? js.debug.jsd.command.Type       : null;
      var Val  = ((typeof js.debug.jsd.command.Value)      == "function") ? js.debug.jsd.command.Value      : null;
      // [v
      var a = -1;
      for(var i = 0; i < jsdParsers.length; i++)
        {
        // allParsers̃CfbNXǔ
        for(a++; a < allParsers.length; a++)
          {
          if(allParsers[a] == jsdParsers[i])
            {
            break;
            }
          }
        if(a >= allParsers.length)
          {
          a = -1;
          }
        // ݒ
        if(jsdParsers[i].jsd && jsdParsers[i].target)
          {
          // def̏ϊ
          if(classRange && jsdParsers[i].target.def)
            {
            try
              {
              if(jsdParsers[i].target.def.toLowerCase() != jsdParsers[i].target.def)
                {
                if((jsdParsers[i].target.begin.isAfter(classRange.begin) || jsdParsers[i].target.begin.isEqual(classRange.begin)) && (jsdParsers[i].target.end.isBefore(classRange.end) || jsdParsers[i].target.end.isEqual(classRange.end)))
                  {
                  jsdParsers[i].target.def = jsdParsers[i].target.def.toLowerCase();
                  }
                }
              }
            catch(e)
              {
              log.debug("def̏ϊɎs܂B", e);
              }
            }
          // RXgN^def̐ݒ
          if(className && jsdParsers[i].target.value && jsdParsers[i].target.def)
            {
            if((jsdParsers[i].target.def == "F") && (jsdParsers[i].target.value == className))
              {
              jsdParsers[i].target.def = "c";
              }
            }
          // def̎ݒ
          if(Def && !jsdParsers[i].jsd.hasCommand(Def.name) && jsdParsers[i].target.def)
            {
            try
              {
              jsdParsers[i].jsd.addCommand(Def.Static.parse(jsdParsers[i].target.def));
              }
            catch(e)
              {
              log.debug("defR}h̎ݒɎs܂B", e);
              }
            }
          // name̎ݒ
          if(Name && !jsdParsers[i].jsd.hasCommand(Name.name) && jsdParsers[i].target.value)
            {
            try
              {
              jsdParsers[i].jsd.addCommand(Name.Static.parse(jsdParsers[i].target.value));
              }
            catch(e)
              {
              log.debug("nameR}h̎ݒɎs܂B", e);
              }
            }
          // type̎ݒ
          if(Type && !jsdParsers[i].jsd.hasCommand(Type.name) && jsdParsers[i].target.type)
            {
            try
              {
              jsdParsers[i].jsd.addCommand(Type.Static.parse(jsdParsers[i].target.type));
              }
            catch(e)
              {
              log.debug("typeR}h̎ݒɎs܂B", e);
              }
            }
          // value̎ݒ
          if(Val && !jsdParsers[i].jsd.hasCommand(Val.name))
            {
            try
              {
              // ϐ\[X猩邱
              if(jsdParsers[i].target.value && ((typeof jsdParsers[i].target.value) == "string"))
                {
                // lp[T[
                var targetEnd = jsdParsers[i].target.end;
                var lineParsers = [];
                for(var b = a; b >= 0; b--)
                  {
                  var begin = allParsers[b].getRange().begin;
                  if(begin.lineNumber < targetEnd.lineNumber)
                    {
                    break;
                    }
                  else if(begin.lineNumber == targetEnd.lineNumber)
                    {
                    if(begin.charIndex < targetEnd.charIndex)
                      {
                      break;
                      }
                    else if(!allParsers[b].jsd && !allParsers[b].target)
                      {
                      var range = allParsers[b].getRange();
                      if((range.begin.lineNumber == range.end.lineNumber) && (!range.value || ((range.end.charIndex - range.begin.charIndex) > 0)))
                        {
                        lineParsers.unshift(allParsers[b]);
                        }
                      }
                    }
                  }
                for(var b = a; b < allParsers.length; b++)
                  {
                  var begin = allParsers[b].getRange().begin;
                  if(begin.lineNumber > targetEnd.lineNumber)
                    {
                    break;
                    }
                  else if(begin.lineNumber == targetEnd.lineNumber)
                    {
                    if(begin.charIndex < targetEnd.charIndex)
                      {
                      break;
                      }
                    else if(!allParsers[b].jsd && !allParsers[b].target)
                      {
                      var range = allParsers[b].getRange();
                      if((range.begin.lineNumber == range.end.lineNumber) && (!range.value || ((range.end.charIndex - range.begin.charIndex) > 0)))
                        {
                        lineParsers.push(allParsers[b]);
                        }
                      }
                    }
                  }
                // lp[T[PȉłȂݒ
                if(lineParsers.length <= 1)
                  {
                  var line = arounds[jsdParsers[i].target.end.lineNumber];
                  if(lineParsers.length == 1)
                    {
                    var valRange = lineParsers[0].getRange();
                    line = line.substring(0, valRange.begin.charIndex) + valRange.value + line.substring(valRange.end.charIndex, line.length);
                    }
                  line = line.substring(jsdParsers[i].target.end.charIndex, line.length);
                  var matches = (/^\s*=\s*(.*?);\s*$/).exec(line);
                  if(matches && matches[1])
                    {
                    // l̂Őݒ
                    jsdParsers[i].jsd.addCommand(Val.Static.parse(matches[1]));
                    // value̎ݒtype̍Đݒ
                    if(Type && !jsdParsers[i].jsd.hasCommand(Type.name))
                      {
                      try
                        {
                        var type = (function(value)
                          {
                          var nest = /^\s*\(\s*(.*?)\s*\)\s*$/;
                          if(nest.test(value))
                            {
                            return arguments.callee(nest.exec(value)[1]);
                            }
                          var types = {};
                          //types["null"]      = /^null$/;
                          //types["undefined"] = /^undefined$/;
                          types["Boolean"]   = /^(?:true|false)$/;
                          types["Number"]    = /^(?:0x|0X)?\d+(?:\.\d+)?$|^NaN$/;
                          types["String"]    = /^".*"$|^'.*'$/;
                          types["Function"]  = /^function\s*\(.*?\)\s*\{.*?\}$/;
                          types["Object"]    = /^\{.*\}$/;
                          types["Array"]     = /^\[.*\]$/;
                          types["RegExp"]    = /^\/.+\/[GIMgim]*$/;
                          for(var type in types)
                            {
                            if((types[type] instanceof RegExp) && types[type].test(value))
                              {
                              return type;
                              }
                            }
                          return "";
                          })(matches[1]);
                        if(type && ((typeof type) == "string"))
                          {
                          jsdParsers[i].jsd.addCommand(Type.Static.parse(type));
                          }
                        }
                      catch(e)
                        {
                        log.debug("valueR}h̎ݒɎs܂B", e);
                        }
                      }
                    }
                  else
                    {
                    log.debug("valueR}h̎ݒɎs܂Bi͑ΏۂPȑłȂ߁j");
                    }
                  }
                else
                  {
                  log.debug("valueR}h̎ݒɎs܂Bi͑Ώۂ݂ł߁j");
                  }
                }
              else
                {
                log.debug("valueR}h̎ݒɎs܂Bi͑Ώۂϐ𔭌łȂ߁j");
                }
              }
            catch(e)
              {
              log.debug("valueR}h̎ݒɎs܂B", e);
              }
            }
          }
        }
      delete Def;
      delete Name;
      delete Type;
      delete Val;
      log.trace("autoDetect() - end");
      }
    //------------------------------------------------------------------------------
    function constructJsd()
     /**
      * ꂽJSD\
      * @return js.debug.jsd.JavaScriptDocument|Array|null JSDCX^X̃c[igbvłȂꍇ͔zj
      */
      {
      log.trace("constructJsd() - begin");
      var root;  // undefined=m, null=Ȃ, JavaScriptDocument=NG[^[JSD
      var obj = [];
      var cache = {};
      var later = {};
      var Def  = js.debug.jsd.command.Definition;
      var Name = js.debug.jsd.command.Name;
      var VarElm = js.debug.jsd.command.element.VariableElement;
      var DefElm = js.debug.jsd.command.element.DefTypeElement;
      var MbrElm = js.debug.jsd.command.element.MemberElement;
      var ClsElm = js.debug.jsd.command.element.ClassElement;
      var key, def, name, p_key, p_def, p_name, p_cls;
      for(var i = 0; i < jsdParsers.length; i++)
        {
        if(jsdParsers[i].jsd)
          {
          // [g̐ݒ
          if(root === undefined)
            {
            var before = arounds.slice(0, jsdParsers[i].getRange().begin.lineNumber).join(ls);
            before += ls + arounds[jsdParsers[i].getRange().begin.lineNumber].substring(0, jsdParsers[i].getRange().begin.charIndex);
            if(before.indexOf("{", 0) < 0)
              {
              root = jsdParsers[i].jsd;
              continue;
              }
            else
              {
              root = null;
              }
            }
          // L[̐
          def = jsdParsers[i].jsd.getCommandByName(Def.name);
          if(def)
            {
            def = def.getValue(DefElm.name);
            }
          name = jsdParsers[i].jsd.getCommandByName(Name.name);
          if(name)
            {
            p_def  = name.getValue(DefElm.name);
            p_name = name.getValue(MbrElm.name);
            p_cls  = name.getValue(ClsElm.name);
            name = name.getValue(VarElm.name);
            }
          key = (def && name) ? (def + ":" + name) : null;
          p_key = (p_def && p_name) ? (p_def + ":" + p_name) : null;
          // L[ɂ鏈
          // NXւ̐ݒi܂oȂ͂j
          if(p_cls)
            {
            obj[obj.length] = jsdParsers[i].jsd;
            }
          // NXւ̐ݒ
          else
            {
            // eL[Ȃe֒ǉ
            if(p_key)
              {
              // eo
              if(cache[p_key])
                {
                cache[p_key].addChild(jsdParsers[i].jsd);
                }
              // eo
              else
                {
                later[p_key] = jsdParsers[i].jsd;  // eȂ̂Ō
                }
              }
            // JSD
            else
              {
              obj[obj.length] = jsdParsers[i].jsd;
              }
            // LbVɒǉ
            if(key && !cache[key])
              {
              cache[key] = jsdParsers[i].jsd;
              }
            }
          }
        }
      // 񂵂̏
      for(var i in later)
        {
        if(later[i])
          {
          if(cache[i])
            {
            cache[i].addChild(later[i]);
            }
          else
            {
            obj[obj.length] = later[i];  // ォłeȂ
            }
          delete later[i];
          }
        }
      // [gȂSĂ[gzɕt
      if(root)
        {
        for(var i = 0; i < obj.length; i++)
          {
          root.addChild(obj[i]);
          }
        }
      // I
      delete cache;
      delete later;
      if(root)
        {
        obj = root;
        }
      else if(obj.length == 0)
        {
        obj = null;
        }
      else if(obj.length == 1)
        {
        obj = obj[0];
        }
      return obj;
      log.trace("constructJsd() - end");
      }
    
    //
    // this - CX^X̌Joƃ\bh(Kpɂp)
    //
    //------------------------------------------------------------------------------
    this.create = function(force)
     /**
      * JSD𐶐
      * @param force [Boolean] p[Xip[XG[Ă𑱍sj邩ǂiȗfalsej
      * @return js.debug.jsd.JavaScriptDocument|Array|null JSDCX^X
      * @throw BooleanFormatException@Error forcev~eBuBoolean^ł`łȂꍇ
      * @throw Error \[X͎̉Ƀp[XG[ꍇ
      */
      {
      log.trace("this.create() - begin - ", force);
      if((force !== undefined) && ((typeof force) != "boolean"))
        {
        throw new Error("BooleanFormatException", Creator.CompleteName, {variable:"force", value:force, type:(typeof force)});
        }
      // (1) sR[h̉
      ls = findLineSeparator(source);
      log.debug("(1/6)sR[h܂B");
      // (2) p[T[̐ƃ\[XRg̏
      makeParsers();
      log.debug("(2/6)p[T[𐶐A\[XRg܂B");
      // (3) SẴp[T[Ńp[X
      parseAll(force);
      log.debug("(3/6)SẴp[T[ŉ͂܂B");
      // (4) JSĎƎݒ
      autoConnect();
      log.debug("(4/6)KvȂJSDA\Ȍ̏ǉ܂B");
      // (5) JSD̎
      autoDetect();
      log.debug("(5/6)͌ʂJSD𐶐܂B");
      // (6) JSD\
      var obj = constructJsd();
      log.debug("(6/6)JSD\܂B");
      // ^[
      log.trace("this.create() - end  - ", obj);
      return obj;
      };
    
    //
    // RXgN^ - CX^X̌Joƃ\bh(pȂ)
    //
    log.trace("JsdFactory() - end - ", this);
    return this;
    }
  
  return Class;
  });

